#ifndef	__LOCK_H__
#define	__LOCK_H__


#include <sys/lock.h>


static struct lock rp_lock;


static __inline void
lock_init()
{
	lockinit(&rp_lock, PCATCH, "tm", 0, 0);
}


static __inline int
lock_shared()
{
	return lockmgr(&rp_lock, LK_SHARED, NULL, NULL);
}


static __inline int
lock_exclusive()
{
	return lockmgr(&rp_lock, LK_EXCLUSIVE, NULL, NULL);
}


static __inline int
lock_exclupgrade()
{
	return lockmgr(&rp_lock, LK_EXCLUPGRADE, NULL, NULL);
}


static __inline int
lock_release()
{
	return lockmgr(&rp_lock, LK_RELEASE, NULL, NULL);
}


#endif	/* __LOCK_H__ */
